Program VeletelenKombinatorika;
(*
    Vletlen permutcik s kombincik generlsi mdszereinek vizsglata.
*)
 Uses
   Newdelay,Crt;
 Const
   MaxN = 9;{"megjelentsi" hatr}
 Type
   TPermutaciok = Record N:byte; perm:Array [1..MaxN] of byte end;
   TKombinaciok = Record N,K:byte; komb:Array [1..MaxN] of byte end;
   TGyakorisag  = Array [1..MaxN,1..MaxN] of longInt;
 Var
   N,K:Integer;
   pe:TPermutaciok;
   ko:TKombinaciok;
   gy:TGyakorisag;

 Function Fakt(Const n:Byte):LongInt;
   Var
     i:Byte;
     f:LongInt;
 Begin
   f:=1;
   For i:=2 to n do f:=f*i;
   Fakt:=f
 End;{Fakt}

 Procedure Inic;
   Var
     i,j:Byte;
 Begin
   ClrScr;
   Writeln('Vletlen kombinatorika':51);
   For i:=1 to MaxN do for j:=1 to MaxN do gy[i,j]:=0;
   Repeat
     Write('N:'); {$i-}Readln(N){$i+}
   Until (IOResult=0) and (N in [1..MaxN]);
   Repeat
     Write('K:'); {$i-}Readln(K){$i+}
   Until (IOResult=0) and (K in [1..N]);
 End;{Inic}

 Procedure GyakorisagMegjelenites(const cim:String; const ig:Integer);
   Var
     i,j:Byte;
     gyo:Array [1..MaxN] of LongInt;
     min,max:LongInt;
     c:Char;
 Begin
   ClrScr;
   Writeln(cim:((6+ig*7+Length(cim)) Div 2)); Writeln;
   Write('      ');
   For j:=1 to ig do Write(j:6,'');
   Writeln;
   Write('');
   For j:=1 to ig do Write('');
   For j:=1 to ig do gyo[j]:=0;
   Writeln;
   For i:=1 to N do
   Begin
     Write(i:5,':');
     For j:=1 to ig do
     Begin
       Write(gy[i,j]:6,'');
       Inc(gyo[j],gy[i,j])
     End;
     Writeln
   End;
   Write('Szumm:');
   For j:=1 to ig do Write(gyo[j]:6,'');
   Writeln;
   Writeln('Szlssgek:');
   min:=MaxInt; max:=0;
   For i:=1 to N do
   Begin
     For j:=1 to ig do
     Begin
       If gy[i,j]>max then max:=gy[i,j];
       If gy[i,j]<max then min:=gy[i,j]
     End;
   End;
   Writeln('  Min:',min:7);  Writeln('  Max:',max:7);
   Writeln('  (Max-Min)/Max:',(max-min)/max:7:5);
   Write(#10#13'Mehetnk? ');
   c:='|';
   While not KeyPressed do
   Begin
     GotoXY(WhereX-1,WhereY); Delay(200);
     Case c of
       '|' : c:='/';
       '/' : c:='-';
       '-' : c:='\';
       '\' : c:='|';
     End;
     Write(c);
   End;
   ReadKey;
 End;{GyakorisagMegjelenites}

(*
   Permutcigenerlsok:
*)

 Procedure PermInic;
   Var
     i,j:Byte;
 Begin
   For i:=1 to MaxN do for j:=1 to MaxN do gy[i,j]:=0;
   pe.N:=N;
   For i:=1 to MaxN do pe.perm[i]:=i;
 End;{PermInic}

 Procedure VeletlenPermutacioMK;
 (*
    Minimumkivlasztsos rendezs alapjn:
 *)
   Var
     i,j,s:Byte;
   Procedure Csere(Const mit,mivel:Byte);
     Var
       seged:Byte;
   Begin
     seged:=pe.perm[mit]; pe.perm[mit]:=pe.perm[mivel]; pe.perm[mivel]:=seged
   End;{Csere}
 Begin
   For i:=1 to pe.N-1 do
   Begin
     j:=Random(N-i+1)+i;
     s:=pe.perm[i]; Csere(i,j);
   End;
 End;{VeletlenPermutacioMK}

 Procedure VeletlenPermutacioBR;
 (*
    Beillesztses rendezs alapjn:
 *)
   Var
     i,j,s:Byte;
   Procedure JobbraLeptet(Const tol,ig:Byte);
     Var
       i:Byte;
   Begin
     For i:=ig downto tol do pe.perm[i+1]:=pe.perm[i]
   End;{JobbraLeptet}
 Begin
   For i:=2 to pe.N do
   Begin
     j:=Random(i)+1;
     s:=pe.perm[i]; JobbraLeptet(j,i-1); pe.perm[j]:=s
   End;
 End;{VeletlenPermutacioBR}

 Procedure PermErtekeles;
   Var
     i:Byte;
 Begin
   For i:=1 to pe.N do Inc(gy[pe.perm[i],i]);
 End;{PermErtekeles}

 Procedure PermutacioVezerles;
   Var
     i:LongInt;
 Begin
   GotoXY(1,WhereY); Write('Gondolkodom...');
   PermInic;
   For i:=1 to 2*Fakt(N) do
   Begin
     VeletlenPermutacioBR;
     PermErtekeles;
   End;
   GyakorisagMegjelenites('Permutcik (Beillesztses)',N);
   PermInic;
   For i:=1 to 2*Fakt(N) do
   Begin
     VeletlenPermutacioMK;
     PermErtekeles;
   End;
   GyakorisagMegjelenites('Permutcik (Minimumkivlasztsos)',N);
 End;{PermutacioVezerles}

(*
   kombincigenerlsok:
*)

 Procedure KombInic;
   Var
     i,j:Byte;
 Begin
   For i:=1 to MaxN do for j:=1 to MaxN do gy[i,j]:=0;
   ko.N:=N; ko.K:=K;
   For i:=1 to MaxN do ko.komb[i]:=i;
 End;{KombInic}

 Procedure VeletlenKombinacio;
   Var
     i,Db:Byte;
   Procedure Csere(Var x,y:Byte);
     Var
       s:Byte;
   Begin
     s:=x; x:=y; y:=s;
   End;{Csere}
 Begin
   Db:=0;
   For i:=1 to ko.N do
   Begin
     If Random<(ko.K-Db)/(Ko.N-i+1) then
     Begin
       Inc(Db); Csere(ko.komb[i],ko.komb[Db])
     End;
   End;
 End;{VeletlenKombinacio}

 Procedure KombErtekeles;
   Var
     i:Byte;
 Begin
   For i:=1 to ko.K do Inc(gy[ko.komb[i],i]);
 End;{KombErtekeles}

 Procedure KombinacioVezerles;
   Var
     i:LongInt;
 Begin
   GotoXY(1,WhereY); Write('Gondolkodom...');
   KombInic;
   For i:=1 to 2*Fakt(N) do
   Begin
     VeletlenKombinacio;
     KombErtekeles;
   End;
   GyakorisagMegjelenites('Kombincik',ko.K);
 End;{KombinacioVezerles}

Begin
  Inic;
  PermutacioVezerles;
  KombinacioVezerles;
End.
